unit yard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComDrv32, ExtCtrls, ComCtrls, Buttons,mmsystem;

type
  TYR = class(TForm)
    OpenComm: TButton;
    comm: TCommPortDriver;
    CloseComm: TButton;
    Timer1: TTimer;
    Timer2: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Stat: TStatusBar;
    blocks: TListBox;
    ProgressBar1: TProgressBar;
    Timer3: TTimer;
    Abort: TButton;
    CommPort: TComboBox;
    Label3: TLabel;
    ProgressBar2: TProgressBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    checksums: TListBox;
    blockstarts: TListBox;
    Label4: TLabel;
    Label5: TLabel;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Timer4: TTimer;
    procedure OpenCommClick(Sender: TObject);
    procedure CloseCommClick(Sender: TObject);
    procedure commReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure AbortClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure CommPortChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
const
   foots:array[0..123] of char = '<<<RAW CLONE DATA BEFORE THIS - FOLLOWS SETS OF BLOCK START POSITION (L,H), BLOCK LENGHT (L,H) AND CURRENT CHECKSUM (L,H)>>>';

var
  YR: TYR;
  BytesRead,BlockSize,checksum,blockstart:integer;
  SixFlag:boolean;
  buf:array[0..65635] of char;



implementation

uses Unit1, yarw;

{$R *.DFM}

procedure TYR.OpenCommClick(Sender: TObject);

begin
  form1.ComboBox23.itemindex:=0;

  bytesread:=0;

  blocksize:=0;
  blockstart:=0;
  checksum:=0;

  blocks.clear;
  blockstarts.clear;
  checksums.clear;

    label3.caption := form1.combobox23.text;
    label1.caption:=inttohex(BytesRead,4)+'  '+inttostr(BytesRead);
    label2.caption:=inttohex(BlockSize,4)+'  '+inttostr(BlockSize);
    label4.caption:=inttohex(blockstart,4)+'  '+inttostr(blockstart);
    label5.caption:=inttohex(checksum,4)+'  '+inttostr(checksum);

comm.disconnect;
comm.comport:=Unit1.cp[commport.itemindex];
if comm.connect then stat.simpletext:='Waiting';
    BytesRead:=0;
    BlockSize:=0;
    timer3.enabled:=true;
    timer4.enabled:=true;

end;

procedure TYR.CloseCommClick(Sender: TObject);
begin
 comm.disconnect;
 timer1.enabled:=false;
 timer2.enabled:=false;
 timer3.enabled:=false;
 timer4.enabled:=false;
// yr.modalresult:=mrOK;
end;

procedure TYR.commReceiveData(Sender: TObject; DataPtr: Pointer;
  DataSize: Integer);
var p: pchar;
    id,s: string;
begin
 timer4.enabled:=false;

 ID:=buf[0]+buf[1];
 if (id='RD') then
     id:=buf[4]+buf[5]+buf[6]+buf[7];

 with form1 do
 begin
 combobox23.itemindex:=0;
 if (id=#224+#224) then combobox23.itemindex:=16; {vx1}
 if (id=#10+#1) then combobox23.itemindex:=18;    {vx5}
 if (id=#10+#0) then combobox23.itemindex:=12;    {FT-50}
 if (id=#$8e+#$77) then combobox23.itemindex:=28;    {FT-8500}

 if (id='MM') then combobox23.itemindex:=2;
 if (buf[1]+buf[2]='RD') then combobox23.itemindex:=1;

 if (id='FT10') then combobox23.itemindex:=5;
 if (id='FT11') then combobox23.itemindex:=7;
 if (id='FT40') then combobox23.itemindex:=9;
 if (id='FT41') then combobox23.itemindex:=11;
 if (id='FT50') then combobox23.itemindex:=13;
 if (id='FT51') then combobox23.itemindex:=15;
 if (id='VX1R') then combobox23.itemindex:=17;
 if (id='VX5R') then combobox23.itemindex:=19;
 if (id='3000') then combobox23.itemindex:=21;
 if (id='8000') then combobox23.itemindex:=23;
 if (id='8100') then combobox23.itemindex:=25;
 if (id='8500') then combobox23.itemindex:=27;
 if (id='VX10') then combobox23.itemindex:=29;
 yr.progressbar2.max:=filesizes[(combobox23.ItemIndex-4)div 2];

 end;
  label3.caption := form1.combobox23.text;


  p := DataPtr;
  while DataSize > 0 do
  begin
   if not sixflag then
    begin
      stat.simpletext:='Receiving';
      buf[bytesread]:=p^;

      timer1.enabled:=false;
      timer1.enabled:=true;
      timer2.enabled:=false;
      timer3.enabled:=false;

    checksum:=(checksum+ord(buf[bytesread]))and $FFFF;
    inc(BytesRead);
    inc(BlockSize);

    label1.caption:=inttohex(BytesRead,4)+'  '+inttostr(BytesRead);
    label2.caption:=inttohex(BlockSize,4)+'  '+inttostr(BlockSize);
    label4.caption:=inttohex(blockstart,4)+'  '+inttostr(blockstart);
    label5.caption:=inttohex(checksum,4)+'  '+inttostr(checksum);

    progressbar1.position:=bytesread and 127;
    progressbar2.position:=bytesread;

    end
   else
    begin
      timer2.enabled:=true;
      timer1.enabled:=false;
      sixflag:=false;

    end;


    dec( DataSize );
    inc( p );
  end;


end;

procedure TYR.Timer1Timer(Sender: TObject);
var a: char;
begin
 stat.simpletext:='New Block';

  a:=#6;
  if Comm.Connected then Comm.SendData( @a, 1 );

  timer1.enabled:=false;
  timer2.enabled:=true;
  sixflag:=true;

  blockstarts.items.add(inttohex(blockstart,4));
  blockstart:=bytesread;
  blocks.items.add(inttohex(blocksize,4));
  blocksize:=0;
  checksums.items.add(inttohex(checksum,4));
//  checksum:=0;

end;

procedure TYR.FormCreate(Sender: TObject);
begin
//  commport.itemindex:=1;

end;

procedure TYR.Timer2Timer(Sender: TObject);
 var o : integer;
begin
 closecomm.click;
 timer2.enabled:=false;
 stat.simpletext:='Complete';
 progressbar1.position:=127;
 for o := 0 to 123 do
   begin
     buf[bytesread+o]:=foots[o];


   end;
 bytesread:=bytesread+124;
 for o := 0 to blocks.items.count-1 do
    begin
      buf[bytesread]:=char(strtoint('$'+copy(blockstarts.items[o],3,2)));
      buf[bytesread+1]:=char(strtoint('$'+copy(blockstarts.items[o],1,2)));
      buf[bytesread+2]:=char(strtoint('$'+copy(blocks.items[o],3,2)));
      buf[bytesread+3]:=char(strtoint('$'+copy(blocks.items[o],1,2)));
      buf[bytesread+4]:=char(strtoint('$'+copy(checksums.items[o],3,2)));
      buf[bytesread+5]:=char(strtoint('$'+copy(checksums.items[o],1,2)));
     bytesread:=bytesread+6;



    end;
 SNDPLAYSOUND('systemexclamation',1);
 bitbtn1.click;

end;

procedure TYR.Timer3Timer(Sender: TObject);
begin
stat.simpletext:='Time Out';
closecomm.click;
SNDPLAYSOUND('appgpfault',1);
messagedlg('Time Out',mtError,[mbOK],0);
bitbtn2.click;

end;

procedure TYR.AbortClick(Sender: TObject);
begin
 timer4.enabled:=false;
 stat.simpletext:='Abort';
 closecomm.click;
 bitbtn2.click;

end;

procedure TYR.BitBtn3Click(Sender: TObject);
begin
 sndplaysound('open',1);
 bitbtn3.enabled:=false;
 opencomm.click;
end;

procedure TYR.BitBtn4Click(Sender: TObject);
begin
abort.click;

end;

procedure TYR.CommPortChange(Sender: TObject);
begin
 unit1.ini.WriteInteger('Main','CommPort',commport.itemindex);

 YW.CommPort.itemindex:= YR.CommPort.itemindex;
end;

procedure TYR.FormShow(Sender: TObject);
begin
  bitbtn3.enabled:=true;

end;

procedure TYR.Timer4Timer(Sender: TObject);
begin
stat.simpletext:=stat.simpletext+'.';
end;

procedure TYR.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// closecomm.click;
end;

procedure TYR.BitBtn2Click(Sender: TObject);
begin
 YW.modalresult:=mrCancel;

end;

end.
