unit yarw;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComDrv32, ComCtrls, Buttons, ExtCtrls,mmsystem;

type
  TYW = class(TForm)
    comm: TCommPortDriver;
    senddata: TButton;
    decodedata: TButton;
    Send: TButton;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    BitBtn1: TBitBtn;
    CommPort: TComboBox;
    Timer1: TTimer;
    Done: TButton;
    BitBtn2: TBitBtn;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    procedure senddataClick(Sender: TObject);
    procedure commReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure decodedataClick(Sender: TObject);
    procedure SendClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure DoneClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CommPortChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  YW: TYW;
 packet,tempcheck,cksum,checksum,block,packetstart,packetend,numofblocks,radiosize,filesize:integer;
 marker:boolean;

implementation

uses Unit1, yard;

{$R *.DFM}

procedure TYW.senddataClick(Sender: TObject);
 var o,oo:integer;
begin
   begin
     for o := 0 to 7 do
       if (packet<(packetend+1)) then
        begin
          comm.SendData(@unit1.buf[packet+1],1);

           inc(packet);

         end;

     end;

    timer1.enabled:=true;


end;

procedure TYW.commReceiveData(Sender: TObject; DataPtr: Pointer;
  DataSize: Integer);
var
  p: pchar;
  s:string;

begin
timer1.enabled:=false;

  s:='';
  p := DataPtr;
  while DataSize > 0 do
  begin
//  s:=s+inttohex(p^,2)+' ';
//  s:=s+p^;

//  listbox1.items.add(inttohex(bytesread,4)+'  '+inttohex(ord(p^),2)+'  '+char(p^));

    inc(bytesread);
    progressbar2.position:=bytesread and 127;
    progressbar1.position:=bytesread;
    statusbar1.simpletext:='Bytes Sent: '+inttostr(bytesread);
//    label7.caption:=inttohex(bytesread,4);
    if (bytesread=(packetend+2)) then
       begin
         dec(bytesread);
         if (ord(p^)=6) then
          begin
           inc(block);
           send.click;

          end;
       end
    else
       begin

       end;

        dec( DataSize );
        inc( p );


  end;
//   listbox1.items.add(s);

        senddata.Click;
//   label1.caption:=inttostr(bytesread);
//   label2.caption:=inttostr(radiosize);

   if (bytesread>radiosize) then
      begin
        beep;
        done.click;
      end;


end;

procedure TYW.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 comm.disconnect;
end;

procedure TYW.decodedataClick(Sender: TObject);
 var o,oo,block:integer;
begin
bytesread:=0;
block:=0;
numofblocks:=0;

  checksum:=0;
  radiosize:=0;
  progressbar1.position:=0;
  filesize:=strtoint(form1.label1.caption);
  packet:=0;
comm.disconnect;
comm.comport:=Unit1.cp[commport.itemindex];
  if comm.connect then
    begin

       for o := 1 to filesize-1 do
         begin
           if (unit1.buf[o]='<') then
            begin

             marker:=true;
             for oo:= 0 to 123 do
               if not (unit1.buf[o+oo] = yard.foots[oo]) then marker:=false;

             if marker then
              begin
               radiosize:=o-2;
              end;
             marker:=false;

            end;



         end;
       progressbar1.max:=radiosize;
       checksum:=0;

//   label1.caption:=inttostr(radiosize);

   if (radiosize=4817) then//vx-1
   begin
    for o:=2 to $A0 do checksum:=checksum+ord(Buf[o]);
    unit1.Buf[$a0+1]:=chr(checksum);  //vx-1 has positive cksum at $a0, 1..9f added
    for o:= $a1 to radiosize do checksum:=checksum+ord(Buf[o]);
    unit1.Buf[radiosize+1]:=chr($100-checksum);  //vx-1 has complememntary cksum of 1..n, no ack
   end
   else
   begin
    for o := 1 to radiosize do checksum:=(checksum + ord(unit1.buf[o]) );  //and 255;
    unit1.buf[radiosize+1] := char(checksum);
   end;



       numofblocks:=(filesize-radiosize-125)div 6;


    send.Click;

    end;
end;

procedure TYW.SendClick(Sender: TObject);
begin
   if (block<numofblocks) then
     begin
      packetstart:=ord(unit1.buf[radiosize+126+(block*6)])+(ord(unit1.buf[radiosize+126+(block*6)+1])*256);
      packetend:=packetstart+ord(unit1.buf[radiosize+126+(block*6)+2])+(ord(unit1.buf[radiosize+126+(block*6)+3])*256)-1;
      packet:=packetstart;

//      label4.caption := inttohex(packetstart,4);
//      label5.caption := inttohex(packetend,4);

      senddata.click;

     end;


end;

procedure TYW.FormShow(Sender: TObject);
begin
 sndplaysound('systemquestion',1);

label1.caption := form1.combobox23.text;
bitbtn2.enabled:=true;
// if (label1.caption='VX-1R Bin') then bitbtn2.enabled:=false;
bytesread:=0;
block:=0;
numofblocks:=0;

  checksum:=0;
  radiosize:=0;
  progressbar1.position:=0;
  progressbar2.position:=0;
  filesize:=strtoint(form1.label1.caption);
  packet:=0;
  comm.disconnect;

end;

procedure TYW.Timer1Timer(Sender: TObject);
begin
 timer1.enabled:=false;
 sndplaysound('appgpfault',1);
 messagedlg('Time Out',mtError,[mbOK],0);
 done.click;
end;

procedure TYW.DoneClick(Sender: TObject);
begin
 timer1.enabled:=false;
 comm.disconnect;
 YW.modalresult:=mrOK;
end;

procedure TYW.BitBtn1Click(Sender: TObject);
begin
 comm.disconnect;
 timer1.enabled:=false;
end;

procedure TYW.BitBtn2Click(Sender: TObject);
begin
bitbtn2.enabled:=false;
decodedata.click;
end;

procedure TYW.CommPortChange(Sender: TObject);
begin
 unit1.ini.WriteInteger('Main','CommPort',commport.itemindex);

end;

end.
